#include "stdafx.h"
#include <vector>
#include <set>
#include "math.h"
#include "VisualStylesXP.h"
#include "CLMgrEventSink.h"
#include "BGBitmap.h"
#include "TransparentCtrl.h"
#include "ColorCtrl.h"
#include "ColorPicker.h"
#include "FontCtrl.h"
#include "ChatEditCtrl.h"
#include "afxwin.h"
#include "SettingsDlg.h"
#include "Tracker.h"
#include "TrayIcon.h"
#include "BuddyList.h"
#include "ChatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

UINT CNotifyIconData::m_CbMsg = WM_USER+1;
CVisualStylesXP VisualStylesXP;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////////////////////////////////////

CChatDialog::CChatDialog(CWnd* pParent /*=NULL*/) : m_CheckBold(m_bmFrame), 
                                                    m_CheckItalic(m_bmFrame), 
                                                    m_CheckUnderline(m_bmFrame), 
                                                    m_ToolBar(m_bmFrame),
                                                    m_ColorPicker(m_bmFrame),
                                                    m_ChatThreadCtrl(m_bmBG),
                                                    m_ChatEditCtrl(m_bmBG),
                                                    m_StaticMsgTo(m_bmFrame),
                                                    CDialog(CChatDialog::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_crTransBG = GetSysColor(COLOR_BTNFACE);
    m_crTransBGDefault = m_crTransBG;
    m_iTransBG = 5;
}

void CChatDialog::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_CHAT, m_ChatThreadCtrl);
    DDX_Control(pDX, IDC_CHATEDIT, m_ChatEditCtrl);
    DDX_Control(pDX, IDC_LISTEMOTICONS, m_EmotIconsList);
    DDX_Control(pDX, IDC_COLORS, m_ColorPicker);
    DDX_Control(pDX, IDC_FONTLIST, m_FontListbox);
    DDX_Control(pDX, IDC_CHECKBOLD, m_CheckBold);
    DDX_Control(pDX, IDC_CHECKITALIC, m_CheckItalic);
    DDX_Control(pDX, IDC_CHECKUNDERLINE, m_CheckUnderline);
    DDX_Control(pDX, IDC_STATICCHAT, m_ChatStatic);
    DDX_Control(pDX, IDC_STATICCHATEDIT, m_ChatEditStatic);
    DDX_Control(pDX, IDC_BUTTONSEND, m_SendButton);
    DDX_Control(pDX, IDC_BUTTONCALL, m_CallButton);
    DDX_Control(pDX, IDC_COMBOBUDDIES, m_ComboBuddies);
    DDX_Control(pDX, IDC_FONTSIZELIST, m_FontSizeListbox);
    DDX_Control(pDX, IDC_STATICMSGTO, m_StaticMsgTo);
}

BEGIN_MESSAGE_MAP(CChatDialog, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
    ON_WM_ERASEBKGND()
    ON_BN_CLICKED(IDC_COLORS, &CChatDialog::OnColorPlane)
    ON_LBN_SELCHANGE(IDC_FONTLIST, &CChatDialog::OnLbnSelchangeFont)
    ON_LBN_SELCHANGE(IDC_FONTSIZELIST, &CChatDialog::OnLbnSelchangeFontSize)
    ON_BN_CLICKED(IDC_SETTINGS, &CChatDialog::OnSettings)
    ON_BN_CLICKED(IDC_SAVE, &CChatDialog::OnSave)
    ON_BN_CLICKED(IDC_CLEAR, &CChatDialog::OnClear)
    ON_BN_CLICKED(IDC_CHECKBOLD, &CChatDialog::OnBnClickedCheckbold)
    ON_BN_CLICKED(IDC_CHECKITALIC, &CChatDialog::OnBnClickedCheckitalic)
    ON_BN_CLICKED(IDC_CHECKUNDERLINE, &CChatDialog::OnBnClickedCheckunderline)
    ON_BN_CLICKED(IDC_BUTTONSEND, &CChatDialog::OnBnClickedButtonsend)
    ON_BN_CLICKED(IDC_BUTTONSTREAM, &CChatDialog::OnBnClickedButtonStream)
    ON_WM_NCCALCSIZE()
    ON_WM_DESTROY()
    ON_WM_LBUTTONDOWN()
    ON_WM_NCPAINT()
    ON_NOTIFY(NM_CLICK, IDC_LISTEMOTICONS, &CChatDialog::OnNMClickListemoticons)
    ON_CBN_SELCHANGE(IDC_COMBOBUDDIES, &CChatDialog::OnCbnSelchangeComboBuddies)
    ON_WM_SETCURSOR()
    ON_WM_SIZE()
    ON_WM_GETMINMAXINFO()
    ON_WM_SYSCOLORCHANGE()
    ON_WM_SHOWWINDOW()
    ON_MESSAGE(CNotifyIconData::GetCbMsg(),OnTrayIconNotify)
    ON_BN_CLICKED(IDCANCEL, &CChatDialog::OnBnClickedCancel)
END_MESSAGE_MAP()

LRESULT CChatDialog::OnTrayIconNotify(WPARAM wParam, LPARAM lParam)
{
    if (lParam==WM_LBUTTONDOWN)
    {
        if (IsIconic())
        {
            ShowWindow(SW_RESTORE);
            SetForegroundWindow();
            m_ChatEditCtrl.SetSel(-1,-1);
        }
    }
    return 0;
}

BOOL CChatDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

    //IMPORTANT: Don't set dialog window style WS_CLIPCHILDREN! See notes in OnEraseBkgnd!
    ModifyStyle(WS_CLIPCHILDREN,0);

    GetClientRect(&m_rcClient);

    CRect rcThread = GetChildPos(m_ChatThreadCtrl);
	int tbHeight = m_ToolBar.Create(this, IDR_TOOLBAR);
    CRect rcTB(rcThread.left,rcThread.top,rcThread.right,rcThread.top+tbHeight);
    m_ToolBar.SetWindowPos(NULL,rcTB.left,rcTB.top,rcTB.Width(),rcTB.Height(),SWP_NOZORDER|SWP_NOACTIVATE);
    OffsetChildPos(m_ChatThreadCtrl,0,tbHeight+2,0,0);
    CRect rcStThread = GetChildPos(m_ChatStatic);
    CRect rcLb = GetChildPos(m_FontListbox);
    CRect rcStEdit = GetChildPos(m_ChatEditStatic);

    m_rcUpperFrame.SetRect(rcStThread.left-m_iSpace,rcTB.top-m_iSpace,rcStThread.right+m_iSpace+1,rcStThread.bottom+m_iSpace-1);
    m_rcLowerFrame.SetRect(rcStEdit.left-m_iSpace,rcLb.top-m_iSpace,rcStEdit.right+m_iSpace+1,rcStEdit.bottom+m_iSpace);
    m_rcSplitter.SetRect(m_rcUpperFrame.left,m_rcUpperFrame.bottom,m_rcUpperFrame.right,m_rcLowerFrame.top);
    m_Tracker.SetPos(m_rcSplitter.top+m_rcSplitter.Height()/2, m_rcClient);

    m_ColorPicker.CalculateColorItems(255);
    m_ColorPicker.SetSel(0,0);
    LoadBitmapResource(IDB_SWYX);

    m_ClientChat.SetCallbackFunction(&CChatDialog::OnChatEvent, (DWORD)(void*)this);
    m_ClientChat.Register();
    m_ClientChat.Advise();

    CString strServer;
    CString strUser;
    m_ClientChat.GetLogonInfo(strServer, m_Me);

    CString strTitle = CString(L"SwyxIt! Messenger ")+m_Me+CString(L" ")+strServer;
    SetWindowText(strTitle);

    m_ChatThreadCtrl.RedrawFrame();
    m_ChatEditCtrl.RedrawFrame();
    m_FontListbox.GetFontNames();
    m_EmotIconsList.CreateIcons(IDB_EMOTICONS, 19, RGB(255,0,255), m_iIconSpacing);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

    m_FontListbox.SetSelFont(CString("Arial"));
    m_FontSizeListbox.SetPt(10);
    SetDefaultCharFormat();

    CArray<CString, CString &> arNames;
    m_ClientChat.GetSpeedDials(arNames);
    m_ComboBuddies.GetBuddyList(arNames, m_Buddy);

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    m_TrayIcon.AddTrayIcon(m_hWnd,m_hIcon,strTitle,false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CChatDialog::OnDestroy()
{
    CDialog::OnDestroy();
    m_ClientChat.Unregister();
    m_ClientChat.Unadvise();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChatDialog::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChatDialog::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CChatDialog::OnColorPlane()
{
    SetDefaultCharFormat();
}

BOOL CChatDialog::OnWndMsg(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
    return CDialog::OnWndMsg(message, wParam, lParam, pResult);
}

void CChatDialog::SetDefaultCharFormat()
{
    CCharFormat cf( m_CheckBold.GetCheck()!=0,
                    m_CheckItalic.GetCheck()!=0,
                    m_CheckUnderline.GetCheck()!=0,
                    m_FontSizeListbox.GetPt()*20,
                    m_ColorPicker.GetColor(),
                    m_FontListbox.GetSelFont());
    m_ChatEditCtrl.SetDefaultCharFormat(cf);
    //m_ChatEditCtrl.SetFocus();
}

void CChatDialog::OnLbnSelchangeFont()
{
    SetDefaultCharFormat();
}

void CChatDialog::OnLbnSelchangeFontSize()
{
    SetDefaultCharFormat();
}

void CChatDialog::OnBnClickedCheckbold()
{
    SetDefaultCharFormat();
}

void CChatDialog::OnBnClickedCheckitalic()
{
    SetDefaultCharFormat();
}

void CChatDialog::OnBnClickedCheckunderline()
{
    SetDefaultCharFormat();
}

void CChatDialog::OnBnClickedButtonStream()
{
    CByteArray arContent;
    m_ChatEditCtrl.GetContent(arContent, SF_RTF);
    m_ChatThreadCtrl.SetContent(arContent, SF_RTF|SFF_SELECTION);
}

void CChatDialog::OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp)
{
    CDialog::OnNcCalcSize(bCalcValidRects, lpncsp);
}

void CChatDialog::OnNcPaint()
{
    // TODO: Add your message handler code here
    CDialog::OnNcPaint();
}

bool CChatDialog::LoadBitmapResource(int nBitmap)
{
    if (m_bmBG.LoadFromResource(nBitmap))
    {
        m_bmFrame.CopyTransparent(m_iTransBG,m_crTransBG,m_bmBG);
        return true;
    }
    return false;
}

bool CChatDialog::LoadBitmapFile(CString &strFile)
{
    if (!m_bmBG.LoadFromFile(strFile))
    {
        LoadBitmapResource(IDB_SWYX);
    }
    m_bmFrame.CopyTransparent(m_iTransBG,m_crTransBG,m_bmBG);
    return true;
}

void CChatDialog::ClipChild(CWnd &ChildWnd, CRgn &rgnClip)
{
    CRect rcChild = GetChildPos(ChildWnd);
    CRgn rgnChild;
    rgnChild.CreateRectRgn(rcChild.left,rcChild.top,rcChild.right,rcChild.bottom);
    rgnClip.CombineRgn(&rgnClip,&rgnChild,RGN_OR);
}

BOOL CChatDialog::OnEraseBkgnd(CDC* pDC)
{
    return EraseBkgnd(pDC);
}

BOOL CChatDialog::EraseBkgnd(CDC* pDC)
{
    CRect rcClient; GetClientRect(&rcClient);

    CRgn rgnFrames;
    rgnFrames.CreateRoundRectRgn(m_rcUpperFrame.left,m_rcUpperFrame.top,
                                 m_rcUpperFrame.right,m_rcUpperFrame.bottom,
                                 m_iRoundedEdge,m_iRoundedEdge);
    CRgn rgnRound;
    rgnRound.CreateRoundRectRgn(m_rcLowerFrame.left,m_rcLowerFrame.top,
                                m_rcLowerFrame.right,m_rcLowerFrame.bottom,
                                m_iRoundedEdge,m_iRoundedEdge);
    rgnFrames.CombineRgn(&rgnFrames,&rgnRound,RGN_XOR);

    CRgn rgnBG;
    rgnBG.CreateRectRgn(0,0,rcClient.Width(),rcClient.Height());
    rgnBG.CombineRgn(&rgnBG, &rgnFrames, RGN_DIFF);

    //IMPORTANT: Don't set dialog window style WS_CLIPCHILDREN! 
    //Otherwise TRANSPARENT richeditcontrols doesn't get WM_ERASEBKGND messages 
    //from the system in order to erase the background correctly!
    //Instead use regions to ensure flicker free drawing and avoid drawing overhead!
    CRgn rgnClip; rgnClip.CreateRectRgn(0,0,0,0);
    ClipChild(m_ToolBar, rgnClip);
    ClipChild(m_ChatThreadCtrl, rgnClip);
    ClipChild(m_ChatEditCtrl, rgnClip);
    ClipChild(m_ColorPicker, rgnClip);
    ClipChild(m_FontListbox, rgnClip);
    ClipChild(m_FontSizeListbox, rgnClip);
    ClipChild(m_CheckBold, rgnClip);
    ClipChild(m_CheckItalic, rgnClip);
    ClipChild(m_CheckUnderline, rgnClip);
    ClipChild(m_EmotIconsList, rgnClip);
    ClipChild(m_CallButton, rgnClip);
    ClipChild(m_SendButton, rgnClip);
    ClipChild(m_StaticMsgTo, rgnClip);
    rgnFrames.CombineRgn(&rgnFrames,&rgnClip,RGN_XOR);

    pDC->SelectClipRgn(&rgnFrames);
    m_bmFrame.DrawPattern(pDC, rcClient);

    pDC->SelectClipRgn(&rgnBG);
    COLORREF crTransBG = RGB(MulDiv(GetRValue(m_crTransBG),m_iDeltaBG,100),
                             MulDiv(GetGValue(m_crTransBG),m_iDeltaBG,100),
                             MulDiv(GetBValue(m_crTransBG),m_iDeltaBG,100));
    CBGBitmap bmBG;
    bmBG.CopyTransparent(m_iTransBG,crTransBG,m_bmBG);
    bmBG.DrawPattern(pDC, rcClient);

    pDC->SelectClipRgn(NULL);
    m_Tracker.DrawGripper(pDC);

    return true;
}

void CChatDialog::OnBnClickedButtonsend()
{
    if( m_Buddy.IsValid()&&(m_ChatEditCtrl.GetTextLength()>0) )
    {
        //(CP_UTF8<<16)|SF_USECODEPAGE
        //m_ChatEditCtrl.GetContentFile(CString("d:\\rtf.rtf"), SF_RTF|SF_RTFNOOBJS|SFF_PLAINRTF);
        CByteArray arContent;
        m_ChatEditCtrl.GetObjectsContent(arContent);
        HRESULT hr = m_ClientChat.SendMessage(m_Buddy, arContent);
        if(SUCCEEDED(hr))
        {
            m_ChatThreadCtrl.InsertHeadline(m_Me.GetMsgHeader(m_Buddy));
            m_ChatThreadCtrl.SetObjectsContent(arContent,m_EmotIconsList.GetIconList());
            m_ChatEditCtrl.ClearContent();
        }
    }
    m_ChatEditCtrl.SetFocus();
}

void CChatDialog::OnCbnSelchangeComboBuddies()
{
    m_ComboBuddies.GetSelBuddy(m_Buddy);
}

void CChatDialog::OnChatEvent(DWORD dwCookie, long msg, long param)
{
    if (dwCookie)
    {
        ((CChatDialog *)dwCookie)->OnChatEvent((PubCLMgrMessages)msg,param);
    }
}

void CChatDialog::OnChatEvent(PubCLMgrMessages msg, long param)
{
    switch(msg)
    {
        case PubCLMgrChatMessage:
        {
            OnChatMessage();
        }
        break;
        case PubCLMgrChatMessageAck:
        break;
        case PubCLMgrUserDataChangedMessage:
        case PubCLMgrNameKeyStateChangedMessage:
        {
            OnNameKeyStateChanged(param);
        }
        break;
    }
}

void CChatDialog::OnNameKeyStateChanged(long lNameKeyIndex)
{
    CArray<CString, CString &> arNames;
    m_ClientChat.GetSpeedDials(arNames);
    m_ComboBuddies.GetBuddyList(arNames, m_Buddy);
}

void CChatDialog::OnChatMessage()
{
    CByteArray arContent;
    HRESULT hr = m_ClientChat.ReadMessage(m_Buddy, arContent);
    if(SUCCEEDED(hr))
    {
        if ( m_Buddy.IsValid()&&(arContent.GetSize()>0) )
        {
            if (IsIconic())
            {
                SendMessage(WM_SYSCOMMAND,SC_RESTORE,0);
            }
            ::SwitchToThisWindow(m_hWnd,TRUE);
            m_ChatThreadCtrl.InsertHeadline(m_Buddy.GetMsgHeader(m_Me));
            m_ChatThreadCtrl.SetObjectsContent(arContent,m_EmotIconsList.GetIconList());
            m_ComboBuddies.IncomingChatMessage(m_Buddy);
            m_ChatEditCtrl.SetFocus();
        }
    }
}

void CChatDialog::OnNMClickListemoticons(NMHDR *pNMHDR, LRESULT *pResult)
{
    LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
    
    if(pNMLV->iItem!=-1)
    {
        m_ChatEditCtrl.InsertEmoticon(m_EmotIconsList.GetIconList(),pNMLV->iItem);
    }
    *pResult = 0;
}

void CChatDialog::OnSave()
{
    // szFilters is a text string that includes two file name filters:
    // "*.my" for "MyType Files" and "*.*' for "All Files."
    TCHAR szFilters[]= L"TXT Files (*.txt)|*.txt|RTF Files (*.rtf)|*.rtf||";

    CFileDialog fileDlg (TRUE, L"rtf", L"*.rtf", OFN_FILEMUSTEXIST|OFN_HIDEREADONLY, szFilters, this);
    if(fileDlg.DoModal()==IDOK)
    {
        CString pathName = fileDlg.GetPathName();
        m_ChatThreadCtrl.GetContentFile(pathName, SF_RTF);
    }
}

void CChatDialog::OnClear()
{
    //RichEditCtrl.Clear does not work, if Ctrl is readonly!
    CByteArray ar;
    m_ChatThreadCtrl.SetContent(ar,SF_RTF);
}

void CChatDialog::SetSettings(CSettingsDlg::CSettingsData &sd)
{
    bool bUpdateDlg = false;
    bool bUpdateChatThread = false;
    bool bUpdateChatEdit = false;
    CCharFormat &cf = m_ChatThreadCtrl.GetCFHeadline();
    if (sd.m_strBitmap!=m_strBitmapFileName)
    {
        m_strBitmapFileName = sd.m_strBitmap;
        LoadBitmapFile(m_strBitmapFileName);
        bUpdateDlg = true;
        bUpdateChatThread = true;
        bUpdateChatEdit = true;
    }
    if (sd.m_cr[0]!=m_crTransBG)
    {
        m_crTransBG = sd.m_cr[0];
        m_bmFrame.CopyTransparent(m_iTransBG,m_crTransBG,m_bmBG);
        bUpdateDlg = true;
    }
    if (sd.m_Transparency[0]!=m_iTransBG)
    {
        m_iTransBG = sd.m_Transparency[0];
        m_bmFrame.CopyTransparent(m_iTransBG,m_crTransBG,m_bmBG);
        bUpdateDlg = true;
    }
    if (sd.m_cr[1]!=m_ChatThreadCtrl.m_crTrans)
    {
        m_ChatThreadCtrl.m_crTrans = sd.m_cr[1];
        bUpdateChatThread = true;
    }
    if (sd.m_Transparency[1]!=m_ChatThreadCtrl.m_iTrans)
    {
        m_ChatThreadCtrl.m_iTrans = sd.m_Transparency[1];
        bUpdateChatThread = true;
    }
    if (sd.m_cr[2]!=m_ChatEditCtrl.m_crTrans)
    {
        m_ChatEditCtrl.m_crTrans = sd.m_cr[2];
        bUpdateChatEdit = true;
    }
    if (sd.m_Transparency[2]!=m_ChatEditCtrl.m_iTrans)
    {
        m_ChatEditCtrl.m_iTrans = sd.m_Transparency[2];
        bUpdateChatEdit = true;
    }
    if (sd.m_cr[3]!=cf.crBackColor)
    {
        cf.crBackColor = sd.m_cr[3];
    }
    if (sd.m_cr[4]!=cf.crTextColor)
    {
        cf.crTextColor = sd.m_cr[4];
    }
    if (bUpdateDlg)
        UpdateDialogBG();
    if (bUpdateChatThread)
        m_ChatThreadCtrl.Invalidate();
    if (bUpdateChatEdit)
        m_ChatEditCtrl.Invalidate();
}

void CChatDialog::UpdateDialogBG()
{
    CDC *pDC = GetDC();
    if (pDC)
    {
        EraseBkgnd(pDC);
        ReleaseDC(pDC);
        m_ToolBar.Invalidate();
        m_ChatStatic.Invalidate();
        m_ComboBuddies.Invalidate();
        m_CheckBold.Invalidate();
        m_CheckItalic.Invalidate();
        m_CheckUnderline.Invalidate();
        m_ColorPicker.Invalidate();
        m_StaticMsgTo.Invalidate();
    }
}

void CChatDialog::OnSettings()
{
    CCharFormat &cf = m_ChatThreadCtrl.GetCFHeadline();
    CCharFormat &cfD = m_ChatThreadCtrl.GetCFHeadlineDefault();
    CSettingsDlg::CSettingsData sd;
    sd.m_strBitmap          = m_strBitmapFileName;
    sd.m_cr[0]              = m_crTransBG;
    sd.m_crDefault[0]       = m_crTransBGDefault;
    sd.m_Transparency[0]    = m_iTransBG;
    sd.m_cr[1]              = m_ChatThreadCtrl.m_crTrans;
    sd.m_crDefault[1]       = m_ChatThreadCtrl.m_crTransDefault;
    sd.m_Transparency[1]    = m_ChatThreadCtrl.m_iTrans;
    sd.m_cr[2]              = m_ChatEditCtrl.m_crTrans;
    sd.m_crDefault[2]       = m_ChatEditCtrl.m_crTransDefault;
    sd.m_Transparency[2]    = m_ChatEditCtrl.m_iTrans;
    sd.m_cr[3]              = cf.crBackColor;
    sd.m_crDefault[3]       = cfD.crBackColor;
    sd.m_Transparency[3]    = -1;
    sd.m_cr[4]              = cf.crTextColor;
    sd.m_crDefault[4]       = cfD.crTextColor;
    sd.m_Transparency[4]    = -1;
    sd.m_pfnSettingsChanged = SettingsChanged;
    sd.m_pWnd               = this;

    m_ComboBuddies.ShowWindow(SW_HIDE);
    CSettingsDlg sdlg(sd,this);
    if (sdlg.DoModal()==IDCANCEL)
    {
        SetSettings(sdlg.GetInitial());
    }
    m_ComboBuddies.ShowWindow(SW_SHOW);
}

void CChatDialog::SettingsChanged(CWnd *pWnd, CSettingsDlg::CSettingsData &sd)
{
    ((CChatDialog *)pWnd)->SetSettings(sd);
}

void CChatDialog::OnLButtonDown(UINT nFlags, CPoint point)
{
    if (m_Tracker.HitTest(point))
    {
        //Clip cursor to ensure minimum height of richedit controls.
        CRect rcThread = GetChildPos(m_ChatThreadCtrl);
        CRect rcEdit = GetChildPos(m_ChatEditCtrl);
        CRect rcClip(0,rcThread.top+m_MinHeight+(point.y-rcThread.bottom),m_rcClient.right,rcEdit.bottom-m_MinHeight-(rcEdit.top-point.y));
        ClientToScreen(&rcClip);
        int iPos = m_Tracker.GetPos();
        TrackChildWindows(m_Tracker.Track(this, rcClip)-iPos);
    }
    else
    {
        CDialog::OnLButtonDown(nFlags, point);
    }
}

BOOL CChatDialog::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
    CPoint pt;
    GetCursorPos(&pt);
    ScreenToClient(&pt);
    if (m_Tracker.HitTest(pt))
    {
        SetCursor(m_Tracker.LoadCursor());
        return true;
    } else return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

void CChatDialog::OnSize(UINT nType, int cx, int cy)
{
    CDialog::OnSize(nType, cx, cy);
    if ((m_ChatThreadCtrl.m_hWnd)&&(nType!=SIZE_MINIMIZED))
    {
        CRect rcThread = GetChildPos(m_ChatThreadCtrl);
        CRect rcEdit = GetChildPos(m_ChatEditCtrl);
        int iPos = m_Tracker.GetPos();
        int iMaxPos = cy-(m_rcClient.Height()-iPos-rcEdit.Height()+m_MinHeight);
        int iMinPos = iPos-rcThread.Height()+m_MinHeight;
        TrackChildWindows(m_Tracker.SetSize(CRect(0,0,cx,cy),iMinPos,iMaxPos)-iPos, cx-m_rcClient.right, cy-m_rcClient.bottom);
        m_rcClient.right = cx;
        m_rcClient.bottom = cy;
    }
}

void CChatDialog::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
    CDialog::OnGetMinMaxInfo(lpMMI);
    lpMMI->ptMinTrackSize.x = m_MinDlgWidth;
    lpMMI->ptMinTrackSize.y = m_MinDlgHeight;
}

CRect CChatDialog::GetChildPos(CWnd &ChildWnd)
{
    CRect rcChild;
    ChildWnd.GetWindowRect(&rcChild);
    ScreenToClient(&rcChild);
    return rcChild;
}

void CChatDialog::OffsetChildPos(CWnd &ChildWnd, int iDeltaX, int iDeltaY)
{
    CRect rcChild = GetChildPos(ChildWnd);
    ChildWnd.SetWindowPos(NULL,rcChild.left+iDeltaX,rcChild.top+iDeltaY,0,0,SWP_NOZORDER|SWP_NOACTIVATE|SWP_NOSIZE);
}

void CChatDialog::OffsetChildPos(CWnd &ChildWnd, int iDeltaX, int iDeltaY, int iDeltaW, int iDeltaH)
{
    CRect rcChild = GetChildPos(ChildWnd);
    rcChild.left+=iDeltaX;
    rcChild.top+=iDeltaY;
    rcChild.right+=iDeltaW;
    rcChild.bottom+=iDeltaH;
    ChildWnd.SetWindowPos(NULL,rcChild.left,rcChild.top,rcChild.Width(),rcChild.Height(),SWP_NOZORDER|SWP_NOACTIVATE);
}

void CChatDialog::TrackChildWindows(int iTDelta/*Tracker*/, int iHDelta/*Width*/, int iVDelta/*Height*/)
{
    m_rcLowerFrame.bottom   +=iVDelta;
    m_rcUpperFrame.right    +=iHDelta;
    m_rcLowerFrame.right    +=iHDelta;
    m_rcSplitter.right      +=iHDelta;

    m_rcUpperFrame.bottom   +=iTDelta;
    m_rcLowerFrame.top      +=iTDelta;
    m_rcSplitter.top        +=iTDelta;
    m_rcSplitter.bottom     +=iTDelta;
    //Offset                         left      top    right   bottom
    OffsetChildPos(m_ToolBar,           0,       0, iHDelta,       0);
    OffsetChildPos(m_ChatThreadCtrl,    0,       0, iHDelta, iTDelta);
    OffsetChildPos(m_ChatEditCtrl,      0, iTDelta, iHDelta, iVDelta);
    OffsetChildPos(m_ChatStatic,        0, iTDelta, iHDelta, iTDelta);
    OffsetChildPos(m_FontListbox,       0, iTDelta);
    OffsetChildPos(m_FontSizeListbox,   0, iTDelta);
    OffsetChildPos(m_CheckBold,         0, iTDelta);
    OffsetChildPos(m_CheckItalic,       0, iTDelta);
    OffsetChildPos(m_CheckUnderline,    0, iTDelta);
    OffsetChildPos(m_ColorPicker,       0, iTDelta);
    OffsetChildPos(m_EmotIconsList,     0, iTDelta);
    OffsetChildPos(m_CallButton,  iHDelta, iTDelta);
    OffsetChildPos(m_SendButton,  iHDelta, iTDelta);
    OffsetChildPos(m_ChatEditStatic,    0, iVDelta, iHDelta, iVDelta);
    OffsetChildPos(m_ComboBuddies,      0, iVDelta, iHDelta, iVDelta);
    OffsetChildPos(m_StaticMsgTo,       0, iVDelta);

    UpdateDialogBG();
}

void CChatDialog::OnSysColorChange()
{
    CDialog::OnSysColorChange();
    if (m_crTransBG==m_crTransBGDefault)
    {
        m_crTransBGDefault = GetSysColor(COLOR_BTNFACE);
        m_crTransBG = m_crTransBGDefault;
        m_bmFrame.CopyTransparent(m_iTransBG,m_crTransBG,m_bmBG);
    }
    else
    {
        m_crTransBGDefault = GetSysColor(COLOR_BTNFACE);
    }
    UpdateDialogBG();
}

void CChatDialog::OnSysCommand(UINT nID, LPARAM lParam)
{
    CDialog::OnSysCommand(nID, lParam);
    if(nID==SC_CLOSE)
    {
        PostQuitMessage(0);
    }
    else if(nID==SC_MINIMIZE)
    {
        ShowWindow(SW_HIDE);
    }
    else if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
}

void CChatDialog::OnShowWindow(BOOL bShow, UINT nStatus)
{
    CDialog::OnShowWindow(bShow, nStatus);
    m_ChatEditCtrl.SetFocus();
}

void CChatDialog::OnBnClickedCancel()
{
    OnCancel();
    PostQuitMessage(0);
}
