#pragma once
#include "afxwin.h"

//////////////////////////////////////////////////////////////////////////////////////////////

class CChatDialog : public CDialog
{
private:
    static const int        m_iRoundedEdge = 6;
    static const int        m_iDeltaBG = 80;
    static const int        m_iIconSpacing = 24;
    static const int        m_iSpace = 4;
    static const int        m_MinHeight = 32;
    static const int        m_MinDlgWidth  = 510;
    static const int        m_MinDlgHeight = 410;
    CBGBitmap               m_bmBG;
    CBGBitmap               m_bmFrame;
    CClientChat             m_ClientChat;
    CTransparentToolbar     m_ToolBar;
    CChatThreadCtrl         m_ChatThreadCtrl;
    CChatEditCtrl           m_ChatEditCtrl;
    CColorPicker            m_ColorPicker;
    CIconListCtrl           m_EmotIconsList;
    CFontListbox            m_FontListbox;
    CTransparentCheckbox    m_CheckBold;
    CTransparentCheckbox    m_CheckItalic;
    CTransparentCheckbox    m_CheckUnderline;
    CStatic                 m_ChatStatic;
    CStatic                 m_ChatEditStatic;
    CButton                 m_SendButton;
    CButton                 m_CallButton;
    CBuddyList              m_ComboBuddies;
    CUserInfo               m_Me;
    CUserInfo               m_Buddy;
    CFontSizeListbox        m_FontSizeListbox;
    CTransparentStatic      m_StaticMsgTo;

    CString                 m_strBitmapFileName;
    COLORREF                m_crTransBG;
    COLORREF                m_crTransBGDefault;
    int                     m_iTransBG;
    CTracker                m_Tracker;

    CRect                   m_rcClient; 
    CRect                   m_rcSplitter;
    CRect                   m_rcUpperFrame;
    CRect                   m_rcLowerFrame;
    CNotifyIconData         m_TrayIcon;

    CRect GetChildPos(CWnd &ChildWnd);
    void OffsetChildPos(CWnd &ChildWnd, int iDeltaVPos, int iDeltaHPos=0);
    void OffsetChildPos(CWnd &ChildWnd, int iDeltaX, int iDeltaY, int iDeltaW, int iDeltaH=0);
    void TrackChildWindows(int iTDelta, int iHDelta=0, int iVDelta=0);
    void UpdateDialogBG();
    void ClipChild(CWnd &ChildWnd, CRgn &rgnClip);

// Construction
public:
	CChatDialog(CWnd* pParent = NULL);	// standard constructor
    void SetDefaultCharFormat();
    bool LoadBitmapResource(int nBitmap);
    bool LoadBitmapFile(CString &strFile);
    void SelBuddy(int i);
    void SetSettings(CSettingsDlg::CSettingsData &sd);
    void GetBuddyList();

public:
    static void OnChatEvent(DWORD dwCookie, long msg, long param);
    void OnChatEvent(PubCLMgrMessages msg, long param);
    void OnChatMessage();
    void OnNameKeyStateChanged(long lNameKeyIndex);
    BOOL EraseBkgnd(CDC* pDC);
    static void SettingsChanged(CWnd *pWnd, CSettingsDlg::CSettingsData &sd);

// Dialog Data
	enum { IDD = IDD_CHAT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnColorPlane();
protected:
    virtual BOOL OnWndMsg(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult);
public:
    afx_msg void OnLbnSelchangeFont();
    afx_msg void OnLbnSelchangeFontSize();
    afx_msg void OnTBSettings();
    afx_msg void OnTBLoad();
    afx_msg void OnTBSave();
    afx_msg void OnBnClickedCheckbold();
    afx_msg void OnBnClickedCheckitalic();
    afx_msg void OnBnClickedCheckunderline();
    afx_msg void OnBnClickedButtonsend();
    afx_msg void OnBnClickedButtonStream();
    afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnNcPaint();
    afx_msg void OnDestroy();
    afx_msg void OnNMClickListemoticons(NMHDR *pNMHDR, LRESULT *pResult);
    afx_msg void OnSettings();
    afx_msg void OnSave();
    afx_msg void OnClear();
    afx_msg void OnCbnSelchangeComboBuddies();
    afx_msg LRESULT OnTrayIconNotify(WPARAM wParam, LPARAM lParam);

protected:

public:
    afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
    afx_msg void OnSysColorChange();
    afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
    afx_msg void OnBnClickedCancel();
};
