#include "stdafx.h"
#include "BGBitmap.h"
#include "ChatEditCtrl.h"

//////////////////////////////////////////////////////////////////////////////////////////////////

CChatEditCtrl::CStreamContent::CStreamContent(CByteArray &arContent, bool bStreamOut, int dwPos) : m_arContent(arContent)
{
    m_dwPos = dwPos;
    dwError = 0;
    if (bStreamOut)
    {
        pfnCallback = EditStreamOutCallback;
    } 
    else
    {
        pfnCallback = EditStreamInCallback;
    }
    dwCookie = (DWORD)this;
}

LONG CChatEditCtrl::CStreamContent::StreamOut(const BYTE *pSrc, LONG cBytes)
{
    m_arContent.SetSize(m_arContent.GetSize()+cBytes,cBytes);      
    memcpy(m_arContent.GetData()+m_dwPos, pSrc, cBytes);
    m_dwPos+=cBytes;
    return cBytes;
}

DWORD CALLBACK CChatEditCtrl::CStreamContent::EditStreamOutCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
    CStreamContent *pSC = (CStreamContent *)dwCookie;
    if (pSC)
    {
        *pcb = pSC->StreamOut(pbBuff, cb);
    }
    return 0;
}

LONG CChatEditCtrl::CStreamContent::StreamIn(BYTE *pDst, LONG cBytes)
{
    LONG dwCopyBytes = m_arContent.GetSize()-m_dwPos;
    if (dwCopyBytes>cBytes)
    {
        dwCopyBytes = cBytes;
    }
    memcpy(pDst, m_arContent.GetData()+m_dwPos, (size_t)dwCopyBytes);
    m_dwPos+=dwCopyBytes;
    return dwCopyBytes;
}

DWORD CALLBACK CChatEditCtrl::CStreamContent::EditStreamInCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
    CStreamContent *pSC = (CStreamContent *) dwCookie;
    if (pSC)
    {
        *pcb = pSC->StreamIn(pbBuff, cb);
    }
    return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////
