#pragma once

///////////////////////////////////////////////////////////////////////////////////////////

class CColorCtrl : public CWnd
{
private:
    CPoint      m_CursorPoint;
    bool        m_bColorPlane;
    CBitmap     m_bmp;

    void NotifyParent();
    void CreateBitmap(int w, int h, BYTE *pRGB);
    void DrawCursor(CPoint& point);
    void RefreshCursor(CDC *pDC);
    void SetSelPoint(float &x, float &y);
    void GetSelPoint(float &x, float &y);

public:
    static void RGBtoHSV(float r, float g, float b, float& h, float& s, float& v);
    static void RGBtoHSV(COLORREF cr, float& h, float& s, float& v)
    {
        RGBtoHSV((float)GetRValue(cr)/255.0f,(float)GetGValue(cr)/255.0f,(float)GetBValue(cr)/255.0f, h, s, v);
    }
    static void HSVtoRGB(float h, float s, float v, float& r, float& g, float& b);
    static COLORREF HSVtoRGB(float h, float s, float v)
    {
        float r,g,b;
        HSVtoRGB(h, s, v, r, g, b);
        return RGB((BYTE)(r*255.0),(BYTE)(g*255.0),(BYTE)(b*255.0));
    }
    void SetColor(COLORREF cr);
    COLORREF GetColor(COLORREF cr=RGB(255,255,255));

public:
	CColorCtrl();
	virtual ~CColorCtrl();
    void DrawColorPlane();
    void DrawGradient();
    int  GetState();
    bool CalcClientRect(RECT &rcClient);
    void RedrawFrame();

protected:
	DECLARE_MESSAGE_MAP()

protected:
public:
    afx_msg void OnPaint();
    afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
    afx_msg LRESULT OnNcHitTest(CPoint point);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
    afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp);
    afx_msg void OnNcPaint();
};


