#pragma once

///////////////////////////////////////////////////////////////////////////////////////////

class CColorPicker : public CWnd
{
private:
    class CColorItem
    {
    public:
        COLORREF    m_cr;
        CRect       m_rcColor;
        CRect       m_rcItem;

        void Draw(CDC *pDC, HTHEME hTheme, int nState, int iInflate=0);
    };

    static const int m_cols = 7;
    static const int m_rows = 4;
    static const int m_space = 2;

    CBGBitmap &m_bm;

    CColorItem m_ColorItems[m_cols][m_rows];
    CPoint m_ptPrev;
    CPoint m_ptSel;

    void NotifyParent();
    bool ColorItemFromPoint(CPoint &pt, int &c, int &r);
    bool Check(int c, int r);

public:
    COLORREF GetColor();

public:
	CColorPicker(CBGBitmap &bm);
	virtual ~CColorPicker();
    void CalculateColorItems(int Saturation);
    int  GetState();
    void DrawFrame(CDC *pDC, CRect &rc, HTHEME hTheme);
    void SetColorItem(int col, int row, COLORREF cr);
    bool SetSel(COLORREF cr);
    void SetSel(int c, int r);

protected:
	DECLARE_MESSAGE_MAP()

public:
    afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
    afx_msg LRESULT OnNcHitTest(CPoint point);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
    afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp);
    afx_msg void OnNcPaint();
    afx_msg void OnPaint();
protected:
    virtual void PreSubclassWindow();
    virtual BOOL OnWndMsg(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult);
public:
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
};
