// Emoticon.h : Declaration of the CEmoticon
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>
#include "Emoticon_h.h"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif


// CEmoticon
class ATL_NO_VTABLE CEmoticon :
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IEmoticon, &IID_IEmoticon, &LIBID_EmoticonLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IPersistStreamInitImpl<CEmoticon>,
	public IOleControlImpl<CEmoticon>,
	public IOleObjectImpl<CEmoticon>,
	public IOleInPlaceActiveObjectImpl<CEmoticon>,
	public IViewObjectExImpl<CEmoticon>,
	public IOleInPlaceObjectWindowlessImpl<CEmoticon>,
#ifdef _WIN32_WCE // IObjectSafety is required on Windows CE for the control to be loaded correctly
	public IObjectSafetyImpl<CEmoticon, INTERFACESAFE_FOR_UNTRUSTED_CALLER>,
#endif
	public CComCoClass<CEmoticon, &CLSID_Emoticon>,
	public CComControl<CEmoticon>
{
private:
    WORD m_nIcon;
    CImageList *m_pEmoticonList;

public:
	CEmoticon()
	{
        m_nIcon = 0;
        m_pEmoticonList = NULL;
	}
    void SetIconNumber(CImageList &EmoticonList, WORD nIcon)
    {
        // convert pixels to himetric
        AtlPixelToHiMetric (&CSize(19,19), &m_sizeExtent);
        m_pEmoticonList = &EmoticonList;
        m_nIcon = nIcon;
    }

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_INSIDEOUT |
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST
)

DECLARE_REGISTRY_RESOURCEID(IDR_EMOTICON)


DECLARE_NOT_AGGREGATABLE(CEmoticon)

BEGIN_COM_MAP(CEmoticon)
	COM_INTERFACE_ENTRY(IEmoticon)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
#ifdef _WIN32_WCE // IObjectSafety is required on Windows CE for the control to be loaded correctly
	COM_INTERFACE_ENTRY_IID(IID_IObjectSafety, IObjectSafety)
#endif
END_COM_MAP()

BEGIN_PROP_MAP(CEmoticon)
	// Example entries
END_PROP_MAP()


BEGIN_MSG_MAP(CEmoticon)
	CHAIN_MSG_MAP(CComControl<CEmoticon>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()

// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

// IEmoticon
public:
	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
        if (m_pEmoticonList)
        {
            CDC *pDC = CDC::FromHandle(di.hdcDraw);
            m_pEmoticonList->Draw(pDC, m_nIcon, CPoint(di.prcBounds->left,di.prcBounds->top),ILD_TRANSPARENT);
        }
	    return S_OK;
    }

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}
};

OBJECT_ENTRY_AUTO(__uuidof(Emoticon), CEmoticon)
