#pragma once
#include "afxcmn.h"
#include "afxwin.h"

#define  cColors    IDC_RADIOCOLORLAST-IDC_RADIOCOLORFIRST+1

class CSettingsDlg : public CDialog
{
public:

    class CSettingsData
    {
        typedef void (* SETTINGSCHANGEDPROC)(CWnd *pWnd, CSettingsDlg::CSettingsData &sd);
    public:
        CString  m_strBitmap;
        COLORREF m_cr[cColors];
        COLORREF m_crDefault[cColors];
        int      m_Transparency[cColors];
        SETTINGSCHANGEDPROC m_pfnSettingsChanged;
        CWnd    *m_pWnd;

    public:
        CSettingsData()
        {
            memset(m_cr, 0, sizeof(m_cr));
            memset(m_crDefault, 0, sizeof(m_crDefault));
            memset(m_Transparency, 0, sizeof(m_Transparency));
            m_pfnSettingsChanged = NULL;
            m_pWnd = NULL;
        }
        void SettingsChanged()
        {
            if (m_pfnSettingsChanged&&m_pWnd)
            {
                m_pfnSettingsChanged(m_pWnd, *this);
            }
        }
    };


private:
    CBGBitmap           m_bm;
    CEdit               m_EditBitmap;
    CButton             m_RadioColor[cColors];
    CColorPicker        m_ColorPicker;
    CColorCtrl          m_ColorPlane;
    CColorCtrl          m_ColorValue;
    CSliderCtrl         m_SliderTransparency;
    CStatic             m_TransLabel;
    CStatic             m_TransValue;
    CSettingsData       m_Initial;
    CSettingsData       m_Current;
    int                 m_nColorItem;

    void SetColorItem(int nColorItem);

public:
	CSettingsDlg(CSettingsData &sd, CWnd* pParent = NULL);   // standard constructor
	~CSettingsDlg();
    void NotifyParent();
    CSettingsData &GetInitial()
    {
        return m_Initial;
    }

// Dialog Data
	enum { IDD = IDD_SETTINGS };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
    virtual BOOL OnInitDialog();
    afx_msg void OnBnClickedButtonBitmap();
    afx_msg void OnEnKillfocusEditbitmap();
    afx_msg void OnRadioColor(UINT nID);
    afx_msg void OnClickedColorpicker();
    afx_msg void OnNMReleasedcaptureSlidertransparency(NMHDR *pNMHDR, LRESULT *pResult);
protected:
    virtual void OnCancel();
public:
    afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
    afx_msg void OnBnClickedDefaultcolor();
    afx_msg void OnColorPlane();
    afx_msg void OnColorValue();
    afx_msg void OnBnClickedRadiocolorfirst();
};
