#include "stdafx.h"
#include "resource.h"
#include "Tracker.h"

CTracker::CTracker()
{
    m_iPos = 0;
    Create(IDB_BMGRIPPER,35,0,RGB(255,0,255));
}

CTracker::~CTracker()
{
}

void CTracker::DrawTrackRect(CDC *pDC, int y)
{
    pDC->MoveTo(m_rcSize.left,m_iPos);
    pDC->LineTo(m_rcSize.right,m_iPos);
}

int CTracker::Track(CWnd* pWnd, CRect &rcClip)
{
    if (pWnd)
    {
	    // set capture to the window which received this message
        pWnd->SetCapture();
        ClipCursor(&rcClip);
        CDC *pDC = pWnd->GetDC();
        if (pDC)
        {
            int mode = pDC->SetROP2(R2_NOT);
            CPen pen(PS_SOLID,5,RGB(0,0,0));
            CPen *pOld = pDC->SelectObject(&pen);
            DrawTrackRect(pDC, m_iPos);
	        // get messages until capture lost or cancelled/accepted
            bool bRun = true;
            MSG msg;
            while( bRun&&::GetMessage(&msg, NULL, 0, 0)&&(msg.message!=0) )
	        {
                if ( (msg.message>=WM_KEYFIRST)&&(msg.message<=WM_KEYLAST)||
                     (msg.message>=WM_MOUSEFIRST)&&(msg.message<=WM_MOUSELAST)&&(msg.message!=WM_MOUSEMOVE) )
                {
                    bRun = false;
                }
                else
                {
		            switch (msg.message)
		            {
		                case WM_MOUSEMOVE:
                        {
                            if (m_iPos!=GET_Y_LPARAM(msg.lParam))
                            {
                                DrawTrackRect(pDC, m_iPos);
                                m_iPos = GET_Y_LPARAM(msg.lParam);
                                DrawTrackRect(pDC, m_iPos);
                            }
			                break;
                        }
                        case WM_SETCURSOR:
                        {
                            LoadCursor();
		                    break;
                        }
		                default:
                        {
			                DispatchMessage(&msg);
			                break;
                        }
		            }
                }
	        }
            DrawTrackRect(pDC, m_iPos);
            pDC->SelectObject(pOld);
            pDC->SetROP2(mode);
            pWnd->ReleaseDC(pDC);

        } //if (pDC)
        ClipCursor(NULL);
        ReleaseCapture();
    } //if (pWnd)
    return m_iPos;
}

