#include "stdafx.h"
#include "TrayIcon.h"

CNotifyIconData::CNotifyIconData()
{
    memset(this,0,sizeof(NOTIFYICONDATA));
    cbSize = sizeof(NOTIFYICONDATA);
    uCallbackMessage= m_CbMsg;
}

CNotifyIconData::~CNotifyIconData()
{
    DeleteTrayIcon();
}

UINT CNotifyIconData::GetCbMsg()
{
    return m_CbMsg;
}

void CNotifyIconData::HideIcon(bool bHidden)
{
    uFlags          = NIF_STATE;
    dwState         = bHidden?NIS_HIDDEN:0;
    dwStateMask     = NIS_HIDDEN;
    Shell_NotifyIcon(NIM_MODIFY,this);
}

void CNotifyIconData::AddTrayIcon(HWND Wnd, HICON Icon, LPCTSTR Tip, bool bHidden)
{
    hWnd        = Wnd;
    uID         = 0;
    hIcon       = Icon;
    dwState     = bHidden?NIS_HIDDEN:0;
    dwStateMask = NIS_HIDDEN;
    uFlags      = NIF_ICON|NIF_TIP|NIF_MESSAGE|NIF_STATE; 
    _tcscpy_s(szTip,Tip);
    Shell_NotifyIcon(NIM_ADD,this);
}

void CNotifyIconData::DeleteTrayIcon()
{
    if (hWnd&&hIcon)
    {
        Shell_NotifyIcon(NIM_DELETE,this);
    }
}
