/*---------------------------------------------------------------------------

   Swyx Solutions
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
  PURPOSE.

  Copyright (C) 2007 Swyx Solutions

  All Rights Reserved.

  ---------------------------------------------------------------------------

     Project:   Swyx Client SDK

      Module:   Visual C++ ATL Client PlugIn sample
 
    Comments:   

----------------------------------------------------------------------------*/


// LdapAddIn.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f LdapAddInps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "LdapAddIn.h"
#include "CLMgrPubTypes.h"
#include "LdapResolver.h"
#include <comdef.h>


CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_LdapResolver, CLdapResolver)
END_OBJECT_MAP()

class CLdapAddInApp : public CWinApp
{
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLdapAddInApp)
	public:
    virtual BOOL InitInstance();
    virtual int ExitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CLdapAddInApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

BEGIN_MESSAGE_MAP(CLdapAddInApp, CWinApp)
	//{{AFX_MSG_MAP(CLdapAddInApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CLdapAddInApp theApp;

BOOL CLdapAddInApp::InitInstance()
{
    _Module.Init(ObjectMap, m_hInstance, &LIBID_LdapAddInLib);
    return CWinApp::InitInstance();
}

int CLdapAddInApp::ExitInstance()
{
    _Module.Term();
    return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return (AfxDllCanUnloadNow()==S_OK && _Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    CString sPlugInSection;
    BSTR    bstrCLSID;
    CString sGuid;
    CString sCompany;

    if(StringFromCLSID(CLSID_LdapResolver, &bstrCLSID)==S_OK)
    {
        sGuid=(char*)_bstr_t(bstrCLSID);
        sCompany.LoadStringA(IDS_COMPANY);
        sPlugInSection=CString("SOFTWARE\\")+sCompany+CString("\\Client Line Manager\\CurrentVersion\\Options\\PlugIns\\")+sGuid;

        HKEY hKey=NULL;

        if(RegCreateKey(HKEY_LOCAL_MACHINE, sPlugInSection, &hKey)==ERROR_SUCCESS)
        {
            CString sName;
            DWORD dwValue=0;
            DWORD dwType=0;
            DWORD dwSize=0;
            char szBuffer[1024];

            sName.LoadString(IDR_MAINFRAME);

            if(sName.IsEmpty())
            {
                sName="Unknown";
            }

            RegSetValueEx(hKey, "FriendlyName", 0, REG_SZ, (unsigned char*)(LPCTSTR)sName, sName.GetLength()+1);

            dwValue=2;
            RegSetValueEx(hKey, "ResolveOrder", 0, REG_DWORD, (LPBYTE)&dwValue, sizeof(DWORD));

            dwValue=1;
            RegSetValueEx(hKey, "FulltextSearchAddinEnabled", 0, REG_DWORD, (LPBYTE)&dwValue, sizeof(DWORD));

            dwValue=0;
            RegSetValueEx(hKey, "ContactAddInSupported", 0, REG_DWORD, (LPBYTE)&dwValue, sizeof(DWORD));

            dwValue=0;
            RegSetValueEx(hKey, "JournalAddInSupported", 0, REG_DWORD, (LPBYTE)&dwValue, sizeof(DWORD));

            dwSize=sizeof(DWORD);

            if(RegQueryValueEx(hKey, "Port", 0, &dwType, (LPBYTE)&dwValue, &dwSize)!=ERROR_SUCCESS)
            {
                dwValue=712;
                RegSetValueEx(hKey, "Port", 0, REG_DWORD, (LPBYTE)&dwValue, sizeof(DWORD));
            }

            dwSize=sizeof(szBuffer);

            if(RegQueryValueEx(hKey, "Server", 0, &dwType, (LPBYTE)szBuffer, &dwSize)!=ERROR_SUCCESS)
            {
                sName="";
                RegSetValueEx(hKey, "Server", 0, REG_SZ, (unsigned char*)(LPCTSTR)sName, sName.GetLength()+1);
            }

            RegCloseKey(hKey);
        }

        CoTaskMemFree(bstrCLSID);

    }

    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    CString sPlugInSection;
    BSTR    bstrCLSID;
    CString sGuid;
    CString sCompany;

    if(StringFromCLSID(CLSID_LdapResolver, &bstrCLSID)==S_OK)
    {
        sGuid=(char*)_bstr_t(bstrCLSID);
        sCompany.LoadStringA(IDS_COMPANY);
        sPlugInSection=CString("SOFTWARE\\")+sCompany+CString("\\Client Line Manager\\CurrentVersion\\Options\\PlugIns\\")+sGuid;

        RegDeleteKey(HKEY_LOCAL_MACHINE, sPlugInSection);

        CoTaskMemFree(bstrCLSID);

    }

    return _Module.UnregisterServer(TRUE);
}


