/*---------------------------------------------------------------------------

   Swyx Solutions GmbH
   Joseph-von-Fraunhofer Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

     Project:  Lotus Notes Integration

      Module:  LotusNotesAccess

    Comments:  

  --------------------------------------------------------------------------

   $Archive:: /Client/OfficeIntegration.root/DialerDll.root/debugout.h     $
    $Author:: Bruessler                                                    $
      $Date:: 31.05.05 16:42                                               $
   $Modtime:: 1.09.04 14:42                                                $
  $Revision:: 3                                                            $
  $Workfile:: debugout.h                                                   $
$NoKeywords: $
----------------------------------------------------------------------------*/


#ifndef _DEBUGOUT_H_
#define _DEBUGOUT_H_




    #define RODS(x)  \
        {\
        TCHAR        szDebug[128];\
        OutputDebugString(TEXT(x));\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        }

    #define RODx(comment,x)  \
        {\
        TCHAR       szDebug[128];\
        wsprintf(szDebug, TEXT("%s%x"), (LPTSTR)comment, (int)x);\
        OutputDebugString(szDebug);\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        }








#ifdef _DEBUGOUTPUT

    #ifndef D
    #define D(x)        {x;}
    #endif

    #define ODS(x)  \
        {\
        TCHAR        szDebug[128];\
        OutputDebugString(TEXT(x));\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        }

    #define ods(x)  \
        {\
        OutputDebugString(TEXT(x));\
        OutputDebugString("\r\n");\
        }

    #define ODsz(comment,s) \
        {\
        TCHAR       szDebug[1024];\
        wsprintf(szDebug, TEXT("%s%s"), (LPTSTR)comment, (LPTSTR)s);\
        OutputDebugString(szDebug);\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        }


    #define odsz(comment,s) \
        {\
        TCHAR       szDebug[1024];\
        wsprintf(szDebug, TEXT("%s%s\r\n"), (LPTSTR)comment, (LPTSTR)s);\
        OutputDebugString(szDebug);\
        }


    #define ODu(comment,u)  \
        {\
        TCHAR       szDebug[128];\
        wsprintf(szDebug, TEXT("%s%u"), (LPTSTR)comment, (UINT)u);\
        OutputDebugString(szDebug);\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        }


    #define ODlu(comment,lu) \
        {\
        TCHAR       szDebug[128];\
        wsprintf(szDebug, TEXT("%s%lu"), (LPTSTR)comment, (DWORD)lu);\
        OutputDebugString(szDebug);\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        }


    #define ODi(comment,i)  \
        {\
        TCHAR       szDebug[128];\
        wsprintf(szDebug, TEXT("%s%i"), (LPTSTR)comment, (int)i);\
        OutputDebugString(szDebug);\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        }


    #define ODli(comment,li) \
        {\
        TCHAR       szDebug[128];\
        wsprintf(szDebug, TEXT("%s%li"), (LPTSTR)comment, (long int)li);\
        OutputDebugString(szDebug);\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        }


    #define ODx(comment,x)  \
        {\
        TCHAR       szDebug[128];\
        wsprintf(szDebug, TEXT("%s%x"), (LPTSTR)comment, (int)x);\
        OutputDebugString(szDebug);\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        }


    #define odx(comment,x)  \
        {\
        TCHAR       szDebug[128];\
        wsprintf(szDebug, TEXT("%s%x\r\n"), (LPTSTR)comment, (int)x);\
        OutputDebugString(szDebug);\
        }


    #define ODlx(comment,lx) \
        {\
        TCHAR       szDebug[128];\
        wsprintf(szDebug, TEXT("%s%lx"), (LPTSTR)comment, (long int)lx);\
        OutputDebugString(szDebug);\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        }


    #define ODd(comment,d)  \
        {\
        TCHAR       szDebug[128];\
        wsprintf(szDebug, TEXT("%s%.1f"), (LPTSTR)comment, (double)d);\
        OutputDebugString(szDebug);\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        }


    #define ODE(comment,e)  \
        {\
        LPVOID lpMsgBuf;\
        FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_MAX_WIDTH_MASK, NULL, e, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL );\
        TCHAR       szDebug[512];\
        wsprintf(szDebug, TEXT("%s%lu (%s)"), (LPTSTR)comment, (DWORD)e, (LPCTSTR)lpMsgBuf);\
        OutputDebugString(szDebug);\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        LocalFree( lpMsgBuf );\
        }

    #define ODEx(comment,e)  \
        {\
        LPVOID lpMsgBuf;\
        FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_MAX_WIDTH_MASK, NULL, e, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL );\
        TCHAR       szDebug[512];\
        wsprintf(szDebug, TEXT("%s%lx (%s)"), (LPTSTR)comment, (DWORD)e, (LPCTSTR)lpMsgBuf);\
        OutputDebugString(szDebug);\
        wsprintf(szDebug, TEXT(" [%s, %u]\r\n"), (LPTSTR)TEXT(__FILE__), __LINE__);\
        OutputDebugString(szDebug);\
        LocalFree( lpMsgBuf );\
        }

#else

    #define D(x)
    #define ODS(x)
    #define ods(x)

    #define ODsz(comment,s)
    #define odsz(comment,s)
    #define ODu(comment,u)
    #define ODlu(comment,lu)
    #define ODi(comment,i)
    #define ODli(comment,li)
    #define ODx(comment,x)
    #define odx(comment,x)
    #define ODlx(comment,lx)
    #define ODd(comment,d)
    #define ODE(comment,e)
    #define ODEx(comment,e)

#endif



#endif
